﻿using System.ComponentModel;

namespace KoloryWPF.ModelWidoku
{
    using Model;

    class EdycjaKoloru : INotifyPropertyChanged
    {
        private Kolor model = Ustawienia.Czytaj();

        public byte R
        {
            get
            {
                return model.R;
            }
            set
            {
                model.R = value;
                OnPropertyChanged(nameof(R), nameof(Color), nameof(Brush));
            }
        }

        public byte G
        {
            get
            {
                return model.G;
            }
            set
            {
                model.G = value;
                OnPropertyChanged(nameof(G), nameof(Color), nameof(Brush));
            }
        }

        public byte B
        {
            get
            {
                return model.B;
            }
            set
            {
                model.B = value;
                OnPropertyChanged(nameof(B), nameof(Color), nameof(Brush));
            }
        }

        //to jest nieeleganckie (w VM nie powinno być odwołań do klas widoku)
        public System.Windows.Media.Color Color
        {
            get
            {
                return new System.Windows.Media.Color()
                {
                    A = 255,
                    R = this.R,
                    G = this.G,
                    B = this.B
                };
            }
        }

        public System.Windows.Media.Brush Brush
        {
            get
            {
                return new System.Windows.Media.SolidColorBrush(Color);
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(params string[] nazwyWłasności)
        {
            if (PropertyChanged != null)
            {
                foreach(string nazwaWłasności in nazwyWłasności)
                    PropertyChanged(this, new PropertyChangedEventArgs(nazwaWłasności));
            }
        }
    }
}
